import { Abstract, DynamicModule, ModuleMetadata, Type } from '@nestjs/common';
import { ACOptions } from './ac-options.interface';
import { RulesBuilder } from './rules-builder.class';
export type Injection = (Type<any> | string | symbol | Abstract<any> | Function)[];
export interface AccessControlOptionsFactory {
    createAccessControlOptions(rules: RulesBuilder, options?: ACOptions): Promise<RulesBuilder> | RulesBuilder;
}
export interface AccessControlModuleAsyncOptions extends Pick<ModuleMetadata, 'imports'> {
    name?: string;
    useExisting?: Type<AccessControlOptionsFactory>;
    useClass?: Type<RulesBuilder>;
    useFactory?: (...args: any[]) => Promise<RulesBuilder> | RulesBuilder;
    inject?: Injection;
}
export declare class AccessControlModule {
    static forRules(rules: RulesBuilder, options?: ACOptions): DynamicModule;
    static forRoot: typeof AccessControlModule.forRules;
    static forRulesAsync(options: AccessControlModuleAsyncOptions): DynamicModule;
    static forRootAsync: typeof AccessControlModule.forRulesAsync;
}
